package com.phlx.anchorcollect.ui.setting;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;

import com.phlx.anchorcollect.bt.BluetoothEntity;

import cn.wandersnail.ble.Device;
import me.goldze.mvvmhabit.base.ItemViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;

public class BleItem extends ItemViewModel<SettingVM> {

    public ObservableField<Device> entity = new ObservableField<>();

    public BleItem(@NonNull SettingVM viewModel, Device entity) {
        super(viewModel);
        this.entity.set(entity);
    }

    //条目的点击事件
    public BindingCommand itemClick = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            viewModel.bleItemOnClick(entity.get());
        }
    });
}
